.\"	$NetBSD: setgroups.2,v 1.17 2006/10/07 21:03:51 elad Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993, 1994
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)setgroups.2	8.2 (Berkeley) 4/16/94
.\"
.Dd October 7, 2006
.Dt SETGROUPS 2
.Os
.Sh NAME
.Nm setgroups
.Nd set group access list
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In sys/param.h
.In unistd.h
.Ft int
.Fn setgroups "int ngroups" "const gid_t *gidset"
.Sh DESCRIPTION
.Fn setgroups
sets the group access list of the current user process
according to the array
.Fa gidset .
The parameter
.Fa ngroups
indicates the number of entries in the array and must be no
more than
.Dv {NGROUPS_MAX} .
.Pp
Only the super-user may set new groups.
.Pp
This system call affects only secondary groups.
.Sh RETURN VALUES
A 0 value is returned on success, \-1 on error, with
an error code stored in
.Va errno .
.Sh ERRORS
The
.Fn setgroups
call will fail if:
.Bl -tag -width Er
.It Bq Er EINVAL
The value of
.Fa ngroups
is greater than
.Dv {NGROUPS_MAX} .
.It Bq Er EPERM
The caller is not the super-user.
.It Bq Er EFAULT
The address specified for
.Fa gidset
is outside the process
address space.
.El
.Sh SEE ALSO
.Xr getgroups 2 ,
.Xr setegid 2 ,
.Xr setgid 2 ,
.Xr setregid 2 ,
.Xr initgroups 3
.Sh HISTORY
The
.Fn setgroups
function call appeared in
.Bx 4.2 .
